<template>
        <ul >
            
            <li v-for="(item,index) in tree" :key='index'>
                <span v-on:click.stop="setSingleSub(item)">
                    
                    
                        <template v-if="item.is_bpmn !== null && item.is_bpmn !== 0">
                            <b><i class="el-icon-success text-success"></i> {{item.SubTenantName}}</b> |
                        </template>
                        <template v-else>
                            <i class="el-icon-news"></i> {{item.SubTenantName}} | 
                        </template>
                        
                        <!-- IF Not BPMN !-->
                        <template v-if="item.is_bpmn == null || item.is_bpmn == 0">
                            <a @click="dialogVisible = true"> <i class="el-icon-circle-plus"></i></a>
                            
                        </template>

                        <a @click="deleteSub(item)"> <i class="el-icon-circle-close-outline"></i></a>
                    

                    <!-- IF BPMN !-->
                    
                   </span>
                <template v-if="item.tree">

                    <tree :tree='item.tree'></tree>

                </template>
                
            </li>
              <el-dialog
                :title="'Create New sub entity  in ' + singleSub.SubTenantName" 
                :visible.sync="dialogVisible"
                width="30%"
                :before-close="handleClose">

                <section >
                    <label class="input"> <i class="icon-append fa fa-user"></i>
                        <input 
                        v-model="c_subTenant.SubTenantName"
                        type="text" name="SubTenantName" placeholder="Name"
                        >
                    </label>
                    
                </section>
               
               <section>
                       <label class="checkbox"> Is Authorized in BPMN ?
                                <input type="checkbox" v-model="c_subTenant.is_bpmn" >
                                <i></i> 
                      </label>
               </section>
                <div class="row">
                <section class="col col-6">
                    <p>Group</p>
                    <label class="select">
                        <select 
                        v-model="c_subTenant.idGroupSubTenants"  name="group">
                            <option v-for="(group,index) in groups" :key="index" :value="group.idGroupSubTenants" >{{group.nameGroupSubTenants}}</option>
                        </select> <i></i> </label>
                </section>
                <section class="col col-6">
                    <p>Type</p>
                    <label class="select">
                        <select v-model="c_subTenant.idSubTenantType">
                            <option v-for="(type,index) in  types" :key="index" :value="type.idSubTenantType">{{type.SubTenantType}}</option>
                        </select> <i></i> </label>
                </section>
                </div>

                <section>
                  
                    <label  class="textarea"> <i class="icon-append fa fa-comment"></i> 										
                        <textarea v-model="c_subTenant.SubTenantDesc" rows="5" name="comment" placeholder="Tell us about your project"></textarea> 
                    </label>
                </section>
                <span slot="footer" class="dialog-footer">
                    <el-button @click="dialogVisible = false"> Cancel </el-button>
                    <el-button type="primary" @click.stop="createSub()">Confirm</el-button>
                </span>
            </el-dialog>
        </ul>

      
        
</template>

<script>
import network from '../../../network'
var $ = require('jquery');
    export default{
        mounted(){
           this.treeJs();
        },
        data(){
            return{
                singleSub:'',
                dialogVisible: false,
                c_subTenant:{},
                network:new network(),
                singleSubCreated:false,
            }
        },
        props:['tree','groups','types'],
        methods:{
            
            setSingleSub(item,event){
                this.singleSub = item ;
                this.$parent.singleSub = this.singleSub ;
            },
            handleClose(done) {
                this.$confirm('Are you sure to close this dialog?')
            .then(_ => {
                done();
            })
            .catch(_ => {});
            },
            createSub(item){
               
                this.c_subTenant.parent_id = this.singleSub.idSubTenant;
                // this.c_subTenant.idGroupSubTenants = 1 ;
                // this.c_subTenant.idSubTenantType = 1 ;
                this.c_subTenant.tree = [] ;
                if(!this.c_subTenant.is_bpmn){
                    this.c_subTenant.is_bpmn = null ;
                }
                
                
                this.network.make('createSubtenant','',this.c_subTenant)
                .then(response => {
                if(response.data.code == 200){
                   
                   /** Set Inserted subTenant */
                      this.c_subTenant = response.data.data ;

                      if(!this.tree[this.tree.indexOf(this.singleSub)].tree){
                          this.tree[this.tree.indexOf(this.singleSub)].tree = [] ;
                      }

                       this.$notify({
                                title: 'Success',
                                message: 'Entity has been created .',
                                type: 'success'
                        });

                      /** Push subtenant to tree array */
                      this.tree[this.tree.indexOf(this.singleSub)].tree.push(this.c_subTenant);

                      this.dialogVisible = false ;
                      this.c_subTenant = {} ;
                      
                      
                }else{
                    //this.subTenants = [] ;
                }
                //this.singleSubCreated =! this.singleSubCreated ;
                })
                .catch(e => {
                this.errors.push(e)
                })
              

            },
            deleteSub(item){
                
                this.$confirm(`
                <div class="alert alert-info" role="alert">
                    <i class="el-alert__icon el-icon-info"></i>
                    Are you sure to delete this ? 
                </div> 
                <div class="alert alert-danger" role="alert">
                    <i class="el-alert__icon el-icon-warning"></i>
                    If this has sub entity it will be deleted !
                </div>
                
                `, '', {
                    dangerouslyUseHTMLString:true,
                    confirmButtonText: 'OK',
                    cancelButtonText: 'Cancel',
                    type: 'danger'
                    }).then(() => {
                        var app = this ;
                        
                        this.network.make('deleteSubtenant','/'+item.idSubTenant,item)
                        .then(response => {
                        if(response.data.code == 200){
                            app.tree.splice(app.tree.indexOf(item),1); 
                            
                            this.$notify({
                                title: 'Success',
                                message: 'Entity has been deleted .',
                                type: 'success'
                            });
                        }

                        })
                        .catch(e => {
                        this.errors.push(e)
                        })

                    }).catch(() => {
                    return false ;     
                });
                
            },
            treeJs(event){
            
            $('.tree > ul').attr('role', 'tree').find('ul').attr('role', 'group');
            var event = event ;
			$('.tree').find('li:has(ul)').addClass('parent_li').find(' > span').on('click', function(event) {
                //e = event ;
				var children = $(this).parent('li.parent_li').find(' > ul > li');
				if (children.is(':visible')) {
					children.hide('fast');
					$(this).attr('title', '').find(' > i').removeClass().addClass('el-icon-news');
				} else {
					children.show('fast');
					$(this).attr('title', '').find(' > i').removeClass().addClass('el-icon-minus');
				}
				e.stopPropagation();
			});			
		
		
            },
            get_Groups(){
            this.network.make('tenantGroup')
              .then(response => {
                if(response.data.code == 200){
                  this.groups = response.data.subTenantGroups ;
                }else{
                  this.groups = [] ;
                }
              })
              .catch(e => {
                this.errors.push(e)
              })
        },
        get_types(){
            this.network.make('tenantType')
              .then(response => {
                if(response.data.code == 200){
                  this.types = response.data.SubTenantType ;
                }else{
                  this.types = [] ;
                }
              })
              .catch(e => {
                this.errors.push(e)
              })
        }
        },
        watch:{
            
            singleSub:{
                handler:function(){
                    this.$parent.singleSub = this.singleSub;
                },
                deep:true
            },
            c_subTenant:{
                handler:function(){
                },
                deep:true
            },
            singleSubCreated:{
                handler:function(){
                    this.$parent.singleSubCreated = this.singleSubCreated;
                },
                deep:true
            },
            tree:{
                handler:function(){
                    this.$parent.singleSubCreated = this.singleSubCreated;
                },
                deep:true
            },
            groups:{
                handler:function(){
                    console.log(this.groups);
                },
                deep:true
                },
                types:{
                handler:function(){
                    
                },
                deep:true
            }
        }
    }
</script>